/*
 * Copyright, 2011, Teradek
 * 
 * All rights reserved.
 * Contact Teradek for licensing.
 */

#ifndef _LIBINTF_H_
#define _LIBINTF_H_

#ifdef __cplusplus
extern "C"
{
#endif
    
#define LIVESTREAM_PLUGIN_LIBRARY   "liblivestream.so"

struct Bond_Plugin;

struct Bond_Plugin* livestream_create_plugin(void);
void livestream_destroy_plugin(struct Bond_Plugin *plugin);

void livestream_start(struct Bond_Plugin *plugin, const char *username, const char *password, const char *channel, const char *event, const int audio_sample_rate, const int audio_no_channels, const float aspect_ratio, const int video_frame_rate_n, const int video_frame_rate_d);
void livestream_stop(struct Bond_Plugin *plugin);
void livestream_send_video(struct Bond_Plugin *plugin, const char* data, const int data_size, const unsigned long long timestamp);
void livestream_send_audio(struct Bond_Plugin *plugin, const char* data, const int data_size, const unsigned long long timestamp);

#ifdef __cplusplus
}
#endif

#endif /* _LIBINTF_H_ */
