/*
 * Copyright, 2011, Teradek
 * 
 * All rights reserved.
 * Contact Teradek for licensing.
 */

#ifndef _LIVESTREAMWRITER_H_
#define _LIVESTREAMWRITER_H_

#include "libintf.h"

#define CONFIG_PARAM_LEN    256

typedef struct
{
    char username[CONFIG_PARAM_LEN];
    char password[CONFIG_PARAM_LEN];
    char channel[CONFIG_PARAM_LEN];
    char event[CONFIG_PARAM_LEN];
        
    float aspect_ratio;
    int video_frame_rate_n;
    int video_frame_rate_d;

    int audio_sample_rate;
    int audio_no_channels;

} LSWRITER_CONFIG;

typedef struct
{
    int start;
    int connect_state;
    
    LSWRITER_CONFIG *cfg;
    
    int firstVideo;
    int firstAudioAAC;
    
    struct Bond_Plugin *plugin;
        
} LSWRITER_HANDLE;

BITSTREAMWRITER_HANDLE LSWriterCreate();
int LSWriterOpen (BITSTREAMWRITER_HANDLE handle, const char *name);
int LSWriterClose(BITSTREAMWRITER_HANDLE handle);
int LSWriterNewBlock(BITSTREAMWRITER_HANDLE handle, char *buf, int len);
int LSWriterIOCTL(BITSTREAMWRITER_HANDLE handle, unsigned int cmd, void *arg);

#endif /* _LIVESTREAMWRITER_H_ */
