/*
 * Copyright, 2013, Teradek
 * 
 * All rights reserved.
 * Contact Teradek for licensing.
 */

#ifndef _PLATFORM_H_
#define _PLATFORM_H_

#ifdef _WIN32
    #include "log.h"
    #include <sys/socket.h>
    #define close_socket(a) {if ((int)a != -1) closesocket(a);}
    #define printf(...) log_mesg(__VA_ARGS__)
    #define fprintf(a,...) log_mesg(__VA_ARGS__)
    #define pollfd pollfd_linux
    #define network_startup(a) {WSADATA wsaData; *(a) = WSAStartup(MAKEWORD(2, 2), &wsaData);}
    #define SIGPIPE SIGILL
    #define net_errno WSAGetLastError()
    #undef EWOULDBLOCK
    #define EWOULDBLOCK WSAEWOULDBLOCK
    #undef EINPROGRESS
    #define EINPROGRESS WSAEINPROGRESS
    #undef EALREADY
    #define EALREADY WSAEALREADY
    #undef EAGAIN
    #define EAGAIN WSAEWOULDBLOCK
    #undef EINTR
    #define EINTR WSAEINTR
    #define ssize_t SSIZE_T
    #define snprintf _snprintf_s
#else
    #define close_socket close
    #define network_startup(a) {*(a) = 0;}
    #define net_errno errno
#endif


#endif
