
#include "ServerCommon.h"

#include "ServerFlv.h"

#include "sys/utsname.h"

#define MAX_PRINT_SIZE 1024

// Defines for onMetaData
#define ONMETA_PRESET_NAME           "Custom"
#define ONMETA_KEYWORDS              ""
#define ONMETA_RATING                ""

// Uncomment this to print RTMP Publish Debug messages
extern int PUBLISH_DEBUG;

// Custom PUBLISH macro for logging
#define RTMP_LOG_PUBLISH(log, fmt, ...) \
    if (PUBLISH_DEBUG) \
        RTMP_LOG_INFO(log, "%s: Publish: "fmt, __FUNCTION__, ## __VA_ARGS__)

void RtmpDebugPrint(INT32 Level, INT8* Format, ...);

int rtmp_lookup_host(RtmpLog *log, const char *host, char *ip);

PublishPoint* GetPublishPoint(PublishServer *publish);

RtmpClient* FindRtmpClient (RtmpSession *rtmpSession, PublishServer *publish);
RtmpSession* FindRtmpSession (RtmpServer *rtmpServer, INT8 *sessionName);

INT32 PerformPublishHandshake (RtmpClient *clientPtr);

INT32 GenerateRtmpChallengeResponse(PublishAuthentication *publishAuth);
INT32 GenerateRtmpChallengeResponseLLNW(PublishAuthentication *publishAuth, INT8 *app);
INT32 GenerateRtmpChallengeResponseAkamai(PublishAuthentication *publishAuth);

INT32 getMacAddress(INT8 *mac_address);

INT32 parseRtmpUrl(INT8 *url, INT8 *ip, INT32 *port, INT8 *file);
