/*
 * Copyright, 2011, Teradek
 *
 * All rights reserved.
 * Contact Teradek for licensing.
 */


#ifndef _RTMP_OSINCLUDES_H_
#define _RTMP_OSINCLUDES_H_

#include <sys/types.h>
#include <pthread.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stddef.h>
#include <unistd.h>
#include <sys/time.h>
#include <signal.h>
#include <time.h>
#include <netdb.h>
#include <limits.h>
#include <sys/signal.h>
#include <sys/errno.h>
#include <sys/times.h>
#ifndef __MACH__
#include <sys/sendfile.h>
#endif
#include <assert.h>
#include <openssl/sha.h>
#include <openssl/hmac.h>
#include <openssl/evp.h>
#include <openssl/rc4.h>

#define RTMPSERVERLIB

#ifndef COMMON_TYPEDEF
    #define COMMON_TYPEDEF      1
    typedef char                INT8;           /* Typedef for signed char        */
    typedef signed short        INT16;          /* Typedef for signed short       */
    typedef signed int          INT32;          /* Typedef for signed int         */
    typedef long long           INT64;

    typedef unsigned char       UINT8;          /* Typedef for unsigned char      */
    typedef unsigned short      UINT16;         /* Typedef for unsigned short     */
    typedef unsigned int        UINT32;         /* Typedef for unsigned int       */
    typedef unsigned long long  UINT64;         /* Typedef for unsigned long long */

    typedef unsigned char       BOOL;           /* Typedef for unsigned char      */
    typedef unsigned char       BYTE;
    typedef short               WORD;
    typedef int                 DWORD;
    typedef unsigned long       ULONG;
    typedef double              FLOAT;
    typedef double              DOUBLE;
    typedef unsigned char       UCHAR;
    typedef unsigned short      USHORT;
    typedef unsigned int        UINT;

    typedef void                VOID;
    typedef void*               SHANDLE;        /* Typedef for void * - as Handle */
    typedef void*               HANDLE;

    typedef INT32                   SOCKET;
    typedef pthread_t               THREAD_HANDLE;
    typedef pthread_mutex_t         LOCK_HANDLE;
    typedef pthread_cond_t          COND_HANDLE;
    typedef struct sockaddr_in      SOCKETADDR_IN;  /* Typedef for struct sockaddr_in */

    #define INVALID_SOCKET          (SOCKET)(~0)
    #define SOCKET_ERROR            (-1)

    typedef INT32 (*THREAD_FUNC) (void *);
#endif

extern INT32 TeradekSyslog(char *module, char *fmt, ...);

#endif /* _RTMP_OSINCLUDES_H_ */
