#pragma once

#include "RtmpPlatformCommon.h"
#include "RtmpPlatformUstream.h"
#include "RtmpPlatformLivestream.h"
#include "RtmpPlatformYouTubeLive.h"
#include "RtmpPlatformWowza.h"
#include "RtmpPlatformTwitch.h"
#include "RtmpPlatformFacebook.h"
#include "RtmpPlatformRTMPXML.h"

typedef struct
{
    char type[128];
    char libname[128];
    RTMP_PLATFORM_FUNCTIONS *functions;
} RTMP_PLATFORM_BYTYPE;

typedef struct {
    char type[SMALL_STRING_LENGTH];
    char errorString[MEDIUM_STRING_LENGTH];
    void *status;
    void *log;
    union {
        UstreamConfig ustream;
        LivestreamConfig livestream;
        YouTubeLiveConfig ytl;
        WowzaConfig wowza;
        TwitchConfig twitch;
        FacebookConfig facebook;
        RTMPXMLConfig rtmpxml;
    } config;
    char checkThread;
    pthread_t CheckThreadId;
    pthread_mutex_t lock;
} RtmpPlatform;

RtmpPlatform* RtmpPlatformCreate(char *type);
int RtmpPlatformConfig(RtmpPlatform *platform, char *configStr);
int RtmpPlatformPublish(RtmpPlatform *platform);
int RtmpPlatformCheck(RtmpPlatform *platform, HANDLE LOG_HANDLE);
int RtmpPlatformStop(RtmpPlatform *platform);
int RtmpPlatformDestroy(RtmpPlatform **platform);
