#pragma once

#include "RtmpOSIncludes.h"

typedef void CURL;

typedef void* RtmpPlatformHandle;

#define SMALL_STRING_LENGTH 128
#define MEDIUM_STRING_LENGTH 1024
#define LARGE_STRING_LENGTH 4096

typedef int (*RTMP_PLATFORM_INIT)(RtmpPlatformHandle p);
typedef int (*RTMP_PLATFORM_CONFIG_ARG)(RtmpPlatformHandle p, char *name, char *value);
typedef int (*RTMP_PLATFORM_PUBLISH)(RtmpPlatformHandle p);
typedef int (*RTMP_PLATFORM_CHECK)(RtmpPlatformHandle p);
typedef int (*RTMP_PLATFORM_STOP)(RtmpPlatformHandle p);
typedef int (*RTMP_PLATFORM_DESTROY)(RtmpPlatformHandle p);

typedef struct
{
    RTMP_PLATFORM_INIT init;
    RTMP_PLATFORM_CONFIG_ARG configArg;
    RTMP_PLATFORM_PUBLISH publish;
    RTMP_PLATFORM_CHECK check;
    RTMP_PLATFORM_STOP stop;
    RTMP_PLATFORM_DESTROY destroy;
} RTMP_PLATFORM_FUNCTIONS;
