#pragma once

#include "RtmpPlatformCommon.h"

#include "livestream_api.h"

#define LIVESTREAM_DEFAULT_SNAPSHOT_FILE "/tmp/jpeg/snapshot.jpg"

typedef struct {
    LS_API_HANDLE *handle;

    char authToken[MEDIUM_STRING_LENGTH];
    char refreshToken[MEDIUM_STRING_LENGTH];
    char accountId[MEDIUM_STRING_LENGTH];
    char eventId[MEDIUM_STRING_LENGTH];
    char title[MEDIUM_STRING_LENGTH];
    int notifyFollowers;
    int bitrate;
    int width;
    int height;
    char post_type[MEDIUM_STRING_LENGTH];

    char urls[2][MEDIUM_STRING_LENGTH];
    char streamName[MEDIUM_STRING_LENGTH];
    char username[MEDIUM_STRING_LENGTH];
    char password[MEDIUM_STRING_LENGTH];
    char videoId[MEDIUM_STRING_LENGTH];
    char broadcastId[MEDIUM_STRING_LENGTH];

    char snapshotFile[MEDIUM_STRING_LENGTH];

    char app[MEDIUM_STRING_LENGTH];
} LivestreamConfig;

extern RTMP_PLATFORM_FUNCTIONS RtmpPlatformLivestream;

int RtmpPlatformLivestreamInit(RtmpPlatformHandle platform);
int RtmpPlatformLivestreamConfigArg(RtmpPlatformHandle platform, char *name, char *value);
int RtmpPlatformLivestreamPublish(RtmpPlatformHandle platform);
int RtmpPlatformLivestreamCheck(RtmpPlatformHandle platform);
int RtmpPlatformLivestreamStop(RtmpPlatformHandle platform);
int RtmpPlatformLivestreamDestroy(RtmpPlatformHandle platform);
