#pragma once

#include "RtmpPlatformCommon.h"

/* From libtd/xmlutil.h */
#define MAX_READBUFSIZE     20000
#define MAX_XMLBUFSIZE      100000
enum
{
   CURL_ERROR,
   HTTP_CODE_BAD_REQUEST,
   HTTP_CODE_NOT_FOUND,
   HTTP_CODE_UNDEFINED_ERR,
   HTTP_CODE_SUCCESS,
   RTMP_XML_ERR_CANNOT_OPEN_FILE,
   RTMP_XML_ERR_PARSE_ERROR,
   RTMP_XML_ERR_MISSING_VALUE,
   RTMP_XML_SUCCESS
};
typedef struct
{
   char *url;
   char *backup_url;
   char *stream;
   char *username;
   char *password;
   char error_string[MAX_READBUFSIZE];
} td_xml_rtmp_profile_st;

int td_xml_rtmp_profile_download(td_xml_rtmp_profile_st *rtmp_xml, char *url);
int td_xml_rtmp_profile_read(td_xml_rtmp_profile_st *rtmp_xml, char *filename);
int td_xml_rtmp_profile_cleanup(td_xml_rtmp_profile_st *rtmp_xml);


typedef struct {
    char xmlurl[MEDIUM_STRING_LENGTH];
    char urls[2][MEDIUM_STRING_LENGTH];
    char streamName[MEDIUM_STRING_LENGTH];
    char username[MEDIUM_STRING_LENGTH];
    char password[MEDIUM_STRING_LENGTH];
} RTMPXMLConfig;

extern RTMP_PLATFORM_FUNCTIONS RtmpPlatformRTMPXML;

int RtmpPlatformRTMPXMLInit(RtmpPlatformHandle platform);
int RtmpPlatformRTMPXMLConfigArg(RtmpPlatformHandle platform, char *name, char *value);
int RtmpPlatformRTMPXMLPublish(RtmpPlatformHandle platform);
int RtmpPlatformRTMPXMLCheck(RtmpPlatformHandle platformHandle);
int RtmpPlatformRTMPXMLStop(RtmpPlatformHandle platform);
int RtmpPlatformRTMPXMLDestroy(RtmpPlatformHandle platform);
