#pragma once

#include "RtmpPlatformCommon.h"

#include "youtubelive_api.h"

typedef struct {
    YTL_API_HANDLE *handle;

    char authToken[MEDIUM_STRING_LENGTH];
    char refreshToken[MEDIUM_STRING_LENGTH];

    char broadcastId[MEDIUM_STRING_LENGTH];
    int preview;
    int stop_event;
    char format[MEDIUM_STRING_LENGTH];
    char title[MEDIUM_STRING_LENGTH];

    char urls[2][MEDIUM_STRING_LENGTH];
    char streamName[MEDIUM_STRING_LENGTH];

    char streamId[MEDIUM_STRING_LENGTH];

    char broadcastState[SMALL_STRING_LENGTH];

    char app[MEDIUM_STRING_LENGTH];
} YouTubeLiveConfig;

extern RTMP_PLATFORM_FUNCTIONS RtmpPlatformYouTubeLive;

int RtmpPlatformYouTubeLiveInit(RtmpPlatformHandle platform);
int RtmpPlatformYouTubeLiveConfigArg(RtmpPlatformHandle platform, char *name, char *value);
int RtmpPlatformYouTubeLivePublish(RtmpPlatformHandle platform);
int RtmpPlatformYouTubeLiveCheck(RtmpPlatformHandle platformHandle);
int RtmpPlatformYouTubeLiveStop(RtmpPlatformHandle platform);
int RtmpPlatformYouTubeLiveDestroy(RtmpPlatformHandle platform);
