/*******************************************************************************
 * Copyright (c) 2008 eInfochips - All rights reserved.
 *
 * This software is authored by eInfochips and is eInfochips' intellectual
 * property, including the copyrights in all countries in the world.
 * This software is provided under a license to use only with all other rights,
 * including ownership rights, being retained by eInfochips.
 *
 * This file may not be distributed, copied, or reproduced in any manner,
 * electronic or otherwise, without the written consent of eInfochips.
 ******************************************************************************/

/******************************************************************************
 *
 * File Name    :   DbgPrint.h
 *
 * Description  :   This file contains definition and implementation of print
 *                  for different type of messages like debug/error/warning.
 * History:
 *  AUG/22/2008, ARJ,   Created the file
 ******************************************************************************/

#ifndef _INCLUDE_DBGPRINT_H
#define _INCLUDE_DBGPRINT_H

/*********************
 * Include Files
 *********************/
#include "RtpRtspInclude.h"
#include "RtpRtspBasicTypes.h"

/* Debug levels supported                                                     */

#define RTP_RTSP_DBG_LEVEL_1        1   /* Lowest debug level                 */
#define RTP_RTSP_DBG_LEVEL_2        2
#define RTP_RTSP_DBG_LEVEL_3        3
#define RTP_RTSP_DBG_LEVEL_4        4
#define RTP_RTSP_DBG_LEVEL_5        5   /* Highest debug level, Enabling this enables all
                                lower debug levels from _LEVEL_4 to _LEVEL_1  */

#define MAX_PRINT_SIZE  1024 /* Max. Debug/info/error print msg size          */

/* Debug Message Error message                                                */
void RtpRtspDebugPrint(INT32 level, INT8* format, ...);

/* Error message                                                              */
void RtpRtspErrorPrint(INT8* format, ...);

/* Informational message                                                      */
void RtpRtspInfoPrint(INT8* format, ...);

#endif /* _INCLUDE_DBGPRINT_H */

/*******************************************************************************
 * Copyright (c) 2008 eInfochips - All rights reserved.
 *
 * This software is authored by eInfochips and is eInfochips' intellectual
 * property, including the copyrights in all countries in the world.
 * This software is provided under a license to use only with all other rights,
 * including ownership rights, being retained by eInfochips.
 *
 * This file may not be distributed, copied, or reproduced in any manner,
 * electronic or otherwise, without the written consent of eInfochips.
 ******************************************************************************/

