/*
* Copyright, 2015, Teradek
*
* All rights reserved.
* Contact Teradek for licensing.
*/

#ifndef _XMLUTIL_H_
#define _XMLUTIL_H_

#define JSON_HEADER         "Content-Type: application/json\n\n"
#define JSON_ERROR_MSG      "{\"error\":\"%s\"}\n"
#define JSON_XML_ERROR_MSG  "{\"error\":\"%s (%s)\"}\n"

#define MAX_READBUFSIZE     20000
#define MAX_XMLBUFSIZE      100000

enum
{
   CURL_ERROR,
   HTTP_CODE_BAD_REQUEST,
   HTTP_CODE_NOT_FOUND,
   HTTP_CODE_UNDEFINED_ERR,
   HTTP_CODE_SUCCESS,
   RTMP_XML_ERR_CANNOT_OPEN_FILE,
   RTMP_XML_ERR_PARSE_ERROR,
   RTMP_XML_ERR_MISSING_VALUE,
   RTMP_XML_SUCCESS
};

typedef struct
{
   char *url;
   char *backup_url;
   char *stream;
   char *username;
   char *password;
   char error_string[MAX_READBUFSIZE];
} td_xml_rtmp_profile_st;

int td_xml_rtmp_profile_download(td_xml_rtmp_profile_st *rtmp_xml, char *url);
int td_xml_rtmp_profile_read(td_xml_rtmp_profile_st *rtmp_xml, char *filename);
int td_xml_rtmp_profile_cleanup(td_xml_rtmp_profile_st *rtmp_xml);

#endif /* _XMLUTIL_H_ */
