
#pragma once

#ifdef __cplusplus
extern "C" {
#endif

// Un-Comment this to enable profilers logging
//#define TDPROFILER_ENABLE

#define TDPROFILER_MAX_TIMES 100
#define TDPROFILER_SHORT_STRING_LENGTH 128
typedef struct
{
    FILE *fp;
    char path[TDPROFILER_SHORT_STRING_LENGTH];
    char name[TDPROFILER_SHORT_STRING_LENGTH];

    char on;

    int iframes;
    int iframes_limit;

    int count;
    struct timeval times[TDPROFILER_MAX_TIMES];
} tdProfiler;

// Profiler
int tdProfilerInit(tdProfiler *p);
void tdProfilerFinish(tdProfiler *p);
void tdProfilerReset(tdProfiler *p);
void tdProfilerAddTime(tdProfiler *p);
void tdProfilerLogTimes(tdProfiler *p, long unsigned int id, char *label);

#ifdef __cplusplus
}
#endif
