
Application['fileTransfer'] = (function() {
  var module = {exports: {}};
  var exports = module.exports;
  Application['fileTransfer'] = exports;

  /* router : fileTransfer */
module.name = "fileTransfer";
module.routes = {"fileTransfer":"index"};
new (Backbone.Router.extend({
    routes: module.routes
    ,index: function() {
        //event aggregator
        var vent = _.extend({}, Backbone.Events);
        //var session = window.location.search.substring(1).split('=')[1];
        Application.sessions = new Thorax.Collections["sessions"]();
        Application.sessions.fetch({
            success:function(){
            var sessions = Application.sessions;

            sessions.initSession();
            //var session =  sessions.getSelected().get('id');
            var transferQ = new Thorax.Collections["fileTransfer/transferQ"](null,{sessions:sessions, vent:vent});
            var transferQView = new Application.Views["fileTransfer/transferQ"]({collection: transferQ, vent:vent});

            var remoteFileManager = new Thorax.Models["fileTransfer/fileManager"]({sessions:sessions, transferQ:transferQ});
            var remoteFileBrowserPanel = new Application.Views["fileTransfer/fileBrowserPanel"]({
                  model:remoteFileManager
                 ,vent:vent
                 ,transferQ:transferQ
                 ,type:'remote'
            });

            var localFileManager = new Thorax.Models["fileTransfer/fileManager"]({sessions:'local', transferQ:transferQ});
            var localFileBrowserPanel = new Application.Views["fileTransfer/fileBrowserPanel"]({
                  model:localFileManager
                 ,vent:vent
                 ,transferQ:transferQ
                 ,type:'local'
            });

            var indexView = new Application.Views["fileTransfer/index"]({
                 local:localFileBrowserPanel
                ,remote:remoteFileBrowserPanel
                ,queue:transferQView
                ,vent:vent
            });
            Application.setView(indexView);
        }, error:function(){ alert('no sputnik sessions available!')}});
    }
}));
;;
Handlebars.templates['fileTransfer/index'] = Handlebars.compile('\n    <div id=\"remote-file-browser\" class=\"col-md-6\">\n        {{view remote}}\n    </div>\n    <div id=\"transfer-file-middle-panel\">\n        <button disabled=\"true\" data-toggle=\"button\" class=\"transfer-remote-local btn btn-default\"><span class=\"glyphicon glyphicon-arrow-right\"></span></button>\n    </div>\n    <div id=\"local-file-browser\" class=\"col-md-6\">\n        {{view local}}\n    </div>\n\n<nav class=\"navbar navbar-default navbar-fixed-bottom\" role=\"navigation\" style=\"background:none;\">\n  <div class=\"container\" style=\"width:100%;\">\n    {{view queue}}\n  </div>\n</nav>\n\n\n');Application.View.extend({
     name: "fileTransfer/index"
    ,initialize:function(){
    }
    ,events: {
        'click .transfer-remote-local':function(){
            this.vent.trigger('transfer:remote-to-local');
        }
    }
});

// Instances of this view can be created by calling:
// new Application.Views["fileTransfer/index"]()
;;
Application.Collection.extend({
    name: "fileTransfer/file"
    ,initialize:function( init, opts ){
       var _this = this;
       if( opts ){
           this.session = opts.session;
           this.devices = opts.devices;
           this.path = opts.path || '/';
       }
       if( this.devices ){
           this.devices.on('change:selected', function(){
               this.path = '/';
               _this.fetch();

           });
       }
    }
    ,fetch: function( options ){
        if( this.devices == null || this.devices == undefined ){
            var device = '';
        }
        else if( this.devices && this.devices.getSelected() ){
            var device = this.devices.getSelected().get('device');
        }
        if( device == undefined){return false;}
        this.url = '/json/'+this.session+'/files/'+device+'?dir='+this.path;
        options = options || {};
        options.resetQueue = true;
        return Application.Collection.prototype.fetch.call(this, options);
    }
    ,parse: function( data ){
        if( 'error' in data ){
            this.trigger('error', this, data);
            return [data];
        }
        var ret = _.map(data, function(el){
            if( 'type' in el && el.type != 'directory' ){
                el.isFile = true;
            }
            else{
                el.isFile = false;
            }
            if( el.path ){
                //bond cmd backend sends '..' at the end of links rather than
                //dereferencing them so let's do it here
                el.path = el.path.replace(/^(.*)\/(.+)\/..$/, '$1');
            }
            return el;
        });
        ret = _.chain(ret)
                .sortBy(function(obj){
                    return obj.name;
                })
               .sortBy(function(obj){
                    return (obj.isFile)?1:0
                })
                .value();
        return ret;
    }
});

// Instances of this collection can be created by calling:
// new Application.Collections["fileTransfer/file"]()
;;
Handlebars.templates['fileTransfer/transferQ-empty'] = Handlebars.compile('0 files Queued');Handlebars.templates['fileTransfer/transferQ-item'] = Handlebars.compile('<li>\n{{device}}:{{path}}\n{{status}}\n<span class=\"glyphicon glyphicon-remove remove pull-right\"></span>\n<div class=\"progress {{status}}\">\n  <div class=\"progress-bar\" role=\"progressbar\" aria-valuenow=\"60\" aria-valuemin=\"0\" aria-valuemax=\"100\" style=\"width: {{completed}};\">\n    {{#if waiting}} waiting {{else}}{{completed}} ({{speed}}){{/if}}\n  </div>\n</div>\n</li>');Handlebars.templates['fileTransfer/transferQ'] = Handlebars.compile('<div class=\"panel panel-default\">\n  <div class=\"panel-heading\" data-toggle=\"collapse\" data-target=\"#transfer-q-panel\"><span>Transfer Queue</span></div>\n  <div  id=\"transfer-q-panel\" class=\"panel-body panel-collapse collapse in\">\n{{#collection tag=\"ol\"}}\n{{/collection}}\n  </div>\n</div>\n');Application.CollectionView.extend({
  name: "fileTransfer/transferQ"
  ,initialize:function(){
      var _this = this;
  }
  ,context: function() {
      return {
          length:function(){
            return '('+this.collection.length+')';
        }
      }
  }
   ,events:{
        'click .remove':function(event){
            var model = $(event.target).model();
            model.destroy();
        }
        ,'error':function(){
        }
    }
});

// Instances of this view can be created by calling:
// new Application.Views["fileTransfer/transferQ"]()
;;
Application.Collection.extend({
     name: "fileTransfer/transferQ"
    ,initialize:function(init, opts){
        var _this = this;
        this.sessions = opts.sessions;
        _this.session = this.sessions.getSelected().get('id');
        this.updateFileTransferStatus();

        this.sessions.on('change:selected', function(session){
           _this.session = session.get('id');
           _this.fetch();
        });

        this.on('destroy', function(model){
            $.ajax({
                url:_this.url()
                ,type:'DELETE'
                ,data:model.toJSON()
            });
        });
        this.vent = opts.vent;

        this.vent.on('transfer:done-adding-queue', function(){
            _this.updateFileTransferStatus();
        })
    }
    ,url:function(){
        if( this.session ){
            return '/json/'+this.session+'/fileTransferQ';
        }
        else{
            return '/';
        }
    }
    ,updateFileTransferStatus:function(){
        var _this = this;
        this.fetch({success:function(){
            var wait = 5000;
            if( _this.length > 0 ){
                _this.active = true;
                wait = 1000;
                //console.log('active!', wait)
            }
            else{
                if( _this.active ){ //was active in last request
                    _this.vent.trigger('transfer:completed');
                    _this.active = false;
                    //console.log('WAS active but now not', wait)
                }
            }
            _this.timeout = setTimeout(function(){
                _this.updateFileTransferStatus()
            }, wait);
        },
        error:function(){
            _this.timeout = setTimeout(function(){
                _this.updateFileTransferStatus()
            }, 10000);
        }});
    }
    ,parse:function(data){
        if( 'error' in data ){
            return [];
        }
        data = _.map(data, function(v){
            if( v.status == 'waiting' ){
                v.waiting = true;
            }
            return v;
        })
        return data;
    }
});

// Instances of this collection can be created by calling:
// new Application.Collections["fileTransfer/transferQ"]()
;;
Handlebars.templates['fileTransfer/fileBrowser-item'] = Handlebars.compile('{{#unless error}}\n            <tr {{#if isFile}}class=\"file\"{{else}}class=\"folder\"{{/if}}>\n              <td class=\"filebrowser-item-icon\">\n                  {{#if isFile}}<span class=\"glyphicon glyphicon-file\"></span>{{else}}<span class=\"glyphicon glyphicon-folder-close\"></span>{{/if}}\n              </td>\n              <td class=\"filebrowser-item-filename\">\n                 <span class=\"filebrowser-item-file-name\" {{#if full_name}}title=\"{{full_name}}\"{{/if}}>{{name}}</span>\n                    <span class=\"filebrowser-item-full-file-name\">{{filename}}</span>\n\n              <div class=\"file-data-under\">\n                  <span>{{human_modified_date}}</span>  {{#if isFile}}<span>{{human_size}}</span>{{/if}}\n              </div>\n\n              {{#if transferQStatus}}\n              {{#with transferQStatus}}\n                <div class=\"progress {{status}}\">\n                  <div class=\"progress-bar\" role=\"progressbar\" aria-valuenow=\"60\" aria-valuemin=\"0\" aria-valuemax=\"100\"\n                   style=\"width: {{completed}} ;\">\n                {{#if waiting}} waiting {{else}}{{completed}} ({{speed}}){{/if}}\n                  </div>\n                </div>\n                {{/with}}\n              {{/if}}\n\n               </td>\n              <td class=\"filebrowser-item-type\">{{type}}</td>\n              <td class=\"filebrowser-item-human-size\">{{#if isFile}}{{human_size}}{{/if}}</td>\n              <td class=\"filebrowser-item-modified-date\">{{human_modified_date}}</td>\n            </tr>\n{{else}}\n            <tr>\n              <td colspan=\"5\">\n               <div class=\"alert alert-danger\">\n                    <span class=\"glyphicon glyphicon-warning-sign\"></span> <strong>Error:</strong> {{error}}\n                </div>\n\n               </td>\n            </tr>\n\n{{/unless}}\n\n');Handlebars.templates['fileTransfer/fileBrowser'] = Handlebars.compile('<table class=\"table\">\n    <thead>\n    <tr>\n        <th class=\"filebrowser-item-icon\"></th>\n        <th class=\"filebrowser-item-filename\">Filename</th>\n        <th class=\"filebrowser-item-type\">Type</th>\n        <th class=\"filebrowser-item-human-size\">Size</th>\n        <th class=\"filebrowser-item-modified-date\">Modified</th>\n    </tr>\n    </thead>\n{{#collection tag=\"tbody\" class=\"table-striped\"}}\n{{/collection}}\n</table>');Application.CollectionView.extend({
     name: "fileTransfer/fileBrowser"
    //,loadingTemplate : 'fileTransfer/fileBrowser-loading'
    ,initialize:function(){
        var _this = this;
       this.vent.on('file-uploader-disabled', function(){
       $('#remote-file-browser [data-view-name="fileTransfer/fileBrowser"] tbody').html(
                    '<tr class="message"><td colspan="5"><div style="margin:100px 50px;">File uploading has not been enabled.'+
                    '<br><br><button class="enable-file-uploader btn btn-primary btn-sm" data-loading-text="Enabling...">Enable File Uploader</button></div></td></tr>')
       });

       this.collection.on('load:end', function(){
          if( _this.collection.session != 'local' ){
              $('#remote-file-browser').unblock();
          }
          $(_this.el).unblock();
       })

       this.on('load:end', function(){console.log('view load:end')})
       this.on('rendered:item', function(){
           _this.setupDragDrop();
       });
    }
    ,setupDragDrop:function(){
        var _this = this;
        if(  'type' in _this && _this.type == 'remote' ){
               $('tbody tr:not(.ui-draggable):not(.folder)', '#remote-file-browser').draggable({
                helper:function(e, ui){
                    $(this).addClass('selected');
                    return $('<table style="z-index:500;"></table>').append(_this.getSelectedFiles().clone());
                }
                ,revert:'invalid'
                ,start:function(event, ui) {
                    $(this).addClass('selected');
                    _this.getSelectedFiles().css('opacity', '.5');
                }
                ,stop: function(event, ui) {
                    _this.getSelectedFiles().css('opacity', '1');
                }
                });
       }
       else{
           $('#local-file-browser table').droppable({
              accept: "#remote-file-browser tr"
              ,activeClass:"you-can-drop-here"
              ,hoverClass: "drop-it-like-its-hot"
              ,drop: function( event, ui ){
                  _this.vent.trigger('transfer:remote-to-local');
              }
            });
       }

    }
    ,getSelectedFiles:function(){
        return $('.selected', this.el);
    }
    ,toggleRow:function(row, skipSelect ) {
        if( !(skipSelect) ){
            var action = $(row).hasClass('selected') ?  'deselect' : 'select';
            if( action == 'select' ){
                $(row).addClass('selected');
            }
            else{
                $(row).removeClass('selected');
            }
        }
        this.lastSelectedRow = row;
        if( $('#remote-file-browser .selected').length ){
            $('.transfer-remote-local').removeAttr('disabled');
        }
        else{
            $('.transfer-remote-local').attr('disabled', true);
        }

        var selectedLocal = $('#local-file-browser .selected').length;
        if( selectedLocal ){
            $('.download-btn').removeAttr('disabled', true);
        }
        else{
            $('.download-btn').attr('disabled', true);
        }

        if( selectedLocal > 1 ){
            $('.download-btn').button('multiple');
        }
        else if( selectedLocal == 1 ){
            $('.download-btn').button('reset');
        }
    }
    ,selectRowsBetweenIndexes:function(ia, ib) {
        var bot = Math.min(ia, ib);
        var top = Math.max(ia, ib);

        var trs = $('tbody tr', this.el);
        for (var i = bot; i <= top; i++) {
            trs[i-1].className = 'selected';
        }
    }
    ,clearAll:function(){
        var trs = $('tbody tr', this.el).removeClass('selected');
        if( $('#remote-file-browser .selected').length == 0 ){
            $('.transfer-remote-local').attr('disabled', true).removeClass('active');
        }
        if( $('#local-file-browser .selected').length == 0 ){
            $('.download-btn').attr('disabled', true).removeClass('active');
        }
    }
    ,itemContext:function( model, i ){
        var attr = _.clone(model.attributes);
        if( 'error' in attr ){
            return attr;
        }

        if( attr.isFile && this.type == 'local' ){
            attr.is_downloadable = true;
        }
        if( attr.name.length > 30 ){
            attr.full_name = attr.name;
            attr.name = this.truncate(attr.name, 30, '...');
        }
        if( attr.size ){
            attr.human_size = filesize(parseInt(attr.size));
        }
        attr.human_modified_date =  moment(attr.modified).format('MM-D-YYYY hh:mm A');
        attr.filename = attr.path.replace(/^.*[/]/, '');

        return attr;
    }
    ,truncate:function( fullStr, strLen, separator ){
        if (fullStr.length <= strLen) return fullStr;

        separator = separator || '...';

        var sepLen = separator.length,
            charsToShow = strLen - sepLen,
            frontChars = Math.ceil(charsToShow/2),
            backChars = Math.floor(charsToShow/2);

        return fullStr.substr(0, frontChars) +
               separator +
               fullStr.substr(fullStr.length - backChars);
    }
    ,events:{
        'mousedown tr':function(event){
            var model = $(event.target).model();
            if( model.get('isFile') ){
                var curRow = event.currentTarget;

                if( event.ctrlKey ){
                    this.toggleRow(curRow);
                }

                if( event.which === 1 ){
                    if( !(event.ctrlKey) && !(event.shiftKey) ){
                       //this.clearAll();
                       this.toggleRow(curRow);
                    }
                    if( event.shiftKey ){
                        if( !(this.lastSelectedRow) ){
                            this.lastSelectedRow = $('tbody tr:first', this.el);
                        }
                        this.selectRowsBetweenIndexes(this.lastSelectedRow.rowIndex, curRow.rowIndex);
                        this.toggleRow(curRow, true);
                    }
                }
            }
            else{
                if( this.type != 'remote' ){ return false; }
                var folder = model.get('path').replace(/^.*[\\\/]/, '');
                $(this.el).block({
                   css:  {
                        backgroundColor: '#000'
                        ,color:'white'
                        ,border:'1px solid gray'
                    }
                    ,message: '<img src="/images/ajax-loader.gif"><br>Loading '+folder+'...'
                    ,fadeIn: 1800
                });
                this.fileManager.set('curPath', model.get('path'));
            }
        }
        ,'rendered':function(){
        }
        ,'error':function(){
        }
        ,'click .enable-file-uploader':function(e){
            $(e.target).button('loading');
            var session = this.collection.devices.session;
            $.ajax({
                url:'/json/'+session+'/settings'
                ,type:'POST'
                ,data:{
                    "Bond.FileUploader.enable":1
                }
            });


            setTimeout(function(){ $('.refresh-btn').click() }, 4000);
        }

    }
});

// Instances of this view can be created by calling:
// new Application.Views["fileTransfer/fileBrowser"]()
;;
Handlebars.templates['fileTransfer/devices'] = Handlebars.compile('<div class=\"btn-group\">\n  <button class=\"btn btn-default btn-sm dropdown-toggle\" type=\"button\" data-toggle=\"dropdown\" style=\"max-width:100%\">\n    <span class=\"cur-device-name\" title=\"{{curDeviceFull}}\">{{curDevice}}</span>\n    <span class=\"caret\"></span>\n  </button>\n{{#collection tag=\"ul\" class=\"dropdown-menu\"}}\n    <li>\n        <a href=\"#\" title=\"{{used}} of {{size}} bytes\">{{name}}</a>\n    </li>\n{{/collection}}\n</div>\n');Application.View.extend({
    name: "fileTransfer/devices"
    ,initialize:function(){
        var _this = this;
        this.loaded = false;
        this.collection.on('change:selected', function(){_this.render();});

        this.collection.on('load:start', function(){

            if( !(_this.loadTimeout) ){
                _this.loadTimeout = setTimeout(function(){
                   $('#remote-file-browser').block({
                   css:  {
                    backgroundColor: '#000'
                    ,color:'white'
                    ,border:'1px solid gray'
                },
                message: '<img src="/images/ajax-loader.gif"><br>Loading...'
                });
                //unblock if nothing loads after 15 seconds
                setTimeout(function(){$('#remote-file-browser').unblock();}, 15000);
                }, 1000);
            }
        })

        this.collection.on('load:end', function(){
            _this.loaded = true;
            clearTimeout(_this.loadTimeout);
            _this.loadTimeout = null;
            if( _this.collection.length == 0 ){
                $('#remote-file-browser').unblock();
            }

        });

        this.collection.on('error', function(err){
            if( err.message == 'file uploader not enabled' ){
                _this.vent.trigger('file-uploader-disabled', err);
            }
        });

    }
    ,events:{
        'click a':function(event){
            var selectedDevice = $(event.target).parent().model();
            this.collection.setSelected(selectedDevice);

            event.preventDefault();
            return false;
        }
        ,'rendered':function(){
            if( this.loaded ){
                $('.cur-device-name', this.el).truncate({width:'auto', side:'center'});
            }

        }
    }
    ,truncate:function( fullStr, strLen, separator ){
        if (fullStr.length <= strLen) return fullStr;

        separator = separator || '...';

        var sepLen = separator.length,
            charsToShow = strLen - sepLen,
            frontChars = Math.ceil(charsToShow/2),
            backChars = Math.floor(charsToShow/2);

        return fullStr.substr(0, frontChars) +
               separator +
               fullStr.substr(fullStr.length - backChars);
    }
    ,context: function() {
        var _this = this;
        return {
            curDevice: function(){
                if( !(_this.loaded) ){
                    return "Loading...";
                }
                if( _this.loaded && _this.collection.length == 0 ){
                    return '[No Devices Available]';
                }
                if( _this.collection.getSelected() ){
                    var curDevice = _this.collection.getSelected().get('name');
                    /*if( curDevice.length > 30 ){
                        curDevice = _this.truncate(curDevice, 30, '...');
                    }*/
                    return curDevice;
                 }
          }
          ,curDeviceFull:function(){
            if( _this.collection.getSelected()){
               return _this.collection.getSelected().get('name');
            }
          }

        };
    }
});

// Instances of this view can be created by calling:
// new Application.Views["fileTransfer/devices"]()
;;
Application.Collection.extend({
    name: "fileTransfer/devices"
    ,initialize:function(){
        var _this = this;

        Application.sessions.on('change:selected', function(session){
           _this.session = session.get('id');
           _this.selected = null;
           _this.fetch({resetQueue: true});
        });
        this.session = Application.sessions.getSelected().get('id');

        this.on('sync', function(){
            if( !(_this.selected) && _this.length > 0 ){
                this.setSelected(_this.findWhere({selected:'1'}));
            }
        });

      }
      ,initSelected:function(){
          var deviceSelected = this.findWhere({selected:'1'});
          var selected = ( deviceSelected ) ? deviceSelected : this.first();
          this.setSelected(selected);
      }
      ,setSelected:function( selected ){
          this.selected = selected;
          this.trigger('change:selected', selected);
      }
      ,getSelected:function(){
          return this.selected;
      }
      ,url:function(){
          if( this.session ){
            return '/json/'+this.session+'/files/devices';
          }
          else{
              return '/';
          }
      }
      ,parse:function(data){
          if( 'error' in data ){
              this.trigger('error', data);
              return [];
          }
          else{
              return data;
          }
      }
});

// Instances of this collection can be created by calling:
// new Application.Collections["fileTransfer/devices"]()
;;
Handlebars.templates['fileTransfer/fileBrowserPanel'] = Handlebars.compile('<div class=\"container-fluid\">\n\n\n<nav class=\"navbar navbar-default\" role=\"navigation\">\n  <div class=\"container-fluid\">\n      <ul class=\"nav navbar-nav\">\n        <li>\n    {{#if devicesView}}\n        {{view sessionsView}}\n    {{else}}\n    <div id=\"local-sputnik-logo\" class=\"navbar-btn btn-sm btn-sm\">\n    <img src=\"/images/sputnik_logo.png\" style=\"height:26px;\">\n    <img src=\"images/sputnik-text.png\" style=\"height: 22px; margin-top:-8px;\">\n    </div>\n    {{/if}}\n        </li>\n\n        <li>\n            <button type=\"button\" class=\"btn btn-default btn-sm navbar-btn refresh-btn\" style=\"margin-right:10px;\">\n            <span class=\"glyphicon glyphicon-refresh\"></span> Refresh</button>\n        </li>\n{{#if devicesView}}\n\n        <li>\n            <button type=\"button\" disabled=\"true\" class=\"transfer-remote-local btn btn-default btn-sm navbar-btn\"\n                    data-loading-text=\"Adding to Queue...\"\n                     style=\"margin-right:10px;\">\n             <span class=\"glyphicon glyphicon-arrow-right\"></span> Transfer\n            </button>\n        </li>\n\n\n{{else}}\n        <li>\n            <button type=\"button\" class=\"btn btn-default btn-sm navbar-btn download-btn\"\n                    data-loading-text=\"Downloading...\"\n                    data-multiple-text=\"<span class=\'glyphicon glyphicon-download\'></span> Download as ZIP\" style=\"margin-right:10px;\">\n             <span class=\"glyphicon glyphicon-download\"></span> Download\n            </button>\n        </li>\n         <!--li>\n            <div class=\"btn-group\" style=\"margin-top:14px;\">\n              <button class=\"btn btn-default btn-sm dropdown-toggle\" type=\"button\" data-toggle=\"dropdown\">\n                /opt/teradek/sputnik/upload <span class=\"caret\"></span>\n              </button>\n            <ul class=\"dropdown-menu\" data-view-cid=\"view38\" data-view-helper=\"collection\" data-collection-element=\"true\"></ul>\n            </div>\n         </li-->\n{{/if}}\n <li style=\"display: block;\nmargin-top: -10px;\nmargin-bottom: 4px;\nwidth: 100%;\n}\">\n                <!--span>Path:</span-->\n            <!--input type=\"text\" value=\"{{curPath}}\" style=\"color:black; width:90%;\" readonly=\"true\"-->\n          Path:\n\n          {{view devicesView}}\n\n          <div class=\"btn-group\">\n            <button type=\"button\" class=\"btn btn-sm btn-default dropdown-toggle\" data-toggle=\"dropdown\" title=\"{{fullPath}}\">\n              {{uploadPath}}{{curPath}}\n              <span class=\"caret\"></span>\n            </button>\n            <ul class=\"dropdown-menu\">\n             {{#each pathCrumbs}}\n              <li><a class=\"path\" href=\"#\" data-value=\"{{fullPath}}\">{{path}}</a></li>\n              {{/each}}\n            </ul>\n          </div>\n            <!--ol class=\"breadcrumb\">\n             {{#each pathCrumbs}}\n              <li><a class=\"path\" href=\"#\" data-value=\"{{fullPath}}\">{{path}}</a></li>\n              {{/each}}\n            </ol-->\n        </li>\n\n        </ul>\n  </div><!-- /.container-fluid -->\n</nav>\n\n{{view fileBrowserView}}\n</div>');Application.View.extend({
    name: "fileTransfer/fileBrowserPanel"
    ,initialize:function(){
        var _this = this;

        if( this.model.get('devicesCollection') ){
            this.devicesView = new Application.Views["fileTransfer/devices"]({
                 collection:  this.model.get('devicesCollection')
                ,fileManager: this.model
                ,vent: this.vent
            });

            if( Application.sessions ){
                this.sessionsView = new Application.Views["sessions"]({
                     collection:  Application.sessions
                    ,vent: this.vent
                });
            }

            this.vent.on('change:session', function(event){
                var selectedSession = $(event.target).parent().model();
                _this.model.set('session', selectedSession);
            });
        }
        else{
            $.ajax({'url':'/sputnik/settings'}).done(function(data){
               console.log(data);
               if( 'upload_path' in data ){
                    _this.upload_path = data.upload_path;
               }
           })
        }
        this.fileBrowserView = new Application.Views["fileTransfer/fileBrowser"]({
              collection: this.model.get('filesCollection')
             ,fileManager: this.model
             ,vent: this.vent
             ,type:this.type
        })

        this.vent.on('transfer:remote-to-local', function(){
            var selectedFiles = _this.fileBrowserView.getSelectedFiles();
            var curDevice = _this.model.get('devicesCollection');
            if( curDevice ){
                var curDevice = curDevice.getSelected().get('device');
                _.each(selectedFiles, function(el) {
                    var filePath = $(el).model().get('path');
                    _this.transferQ.create({device:curDevice, path:filePath});
                })

                _this.vent.trigger('transfer:done-adding-queue');
            }
        });

        this.vent.on('transfer:completed', function(){
            _this.refresh.call(_this);
        });
        this.model.get('transferQ').on('add remove', function(){
            _this.refresh.call(_this);
        });

        $('body').click(function(e){
            if( $(e.target).closest(_this.el).length == 0 ){
                _this.fileBrowserView.clearAll();
            }
        });
    }
    ,refresh:function(delay){
            delay = (delay) ? delay : 2000;
            var files = this.model.get('filesCollection');
            var devices = this.model.get('devicesCollection');
            if( files && !(devices) ){
                setTimeout(function(){files.fetch();}, delay);
            }
        }
    ,context: function() {
        var _this = this;
        return {
            pathCrumbs: function(){
                var curPath = _this.model.get('curPath');
                var ret = _.map(curPath.split('/'), function( el, i, list ){
                    if( i == 0 ){
                        el = '[ROOT]';
                        fullPath = '/';
                    }
                    else{
                        var fullPath = _.reduce(list.slice(1,i+1), function(memo, p){ return memo + '/' + p; }, '');
                    }
                    return {path: el, fullPath:fullPath }
                });
                return ret.reverse();
            }
            ,fullPath:function(){
                return _this.model.get('curPath');
            }
            ,curPath: function(){
                var path = _this.model.get('curPath');
                path = path.replace(/^.*[\\\/]/, '')
                if( path.length > 30 ){
                    path = _this.truncate(path, 30, '...');
                }
                if( $.trim(path) == ""){return "/";}
                return path;
            }
            ,uploadPath: function(){
                if( _this.upload_path ){
                    return _this.upload_path;
                }
            }
        };
    }
    ,truncate:function( fullStr, strLen, separator ){
        if (fullStr.length <= strLen) return fullStr;

        separator = separator || '...';

        var sepLen = separator.length,
            charsToShow = strLen - sepLen,
            frontChars = Math.ceil(charsToShow/2),
            backChars = Math.floor(charsToShow/2);

        return fullStr.substr(0, frontChars) +
               separator +
               fullStr.substr(fullStr.length - backChars);
    }
    ,events:{
         'click .refresh-btn':function(event) {
             $(event.target).button('loading');
            if( this.devicesView ){
                this.devicesView.collection.fetch({success:function(){
                    $(event.target).button('reset');
                }});
            }
            else{
                $(event.target).button('reset');
            }
            this.fileBrowserView.collection.fetch();
        }
        ,'click .download-btn':function(event){

            var files = this.fileBrowserView.getSelectedFiles();
            if( files.length > 0 ){
                $(event.target).button('loading');
                var downloads = _.map(files, function(v){
                    var model = $(v).model();
                    return {path:model.get('path')}
                })
                if( $('#downloadFrame').length == 0){
                    $('body').append('<iframe id="downloadFrame" src="" style="display:none"></iframe>')
                }
                $('#downloadFrame').attr('src', '/json/local/files/download?files='+JSON.stringify(downloads));
                setTimeout(function(){
                    $(event.target).button('reset');
                }, 3000);
            }

        }
        ,'click .path':function(event){
            this.model.set('curPath', $(event.target).data('value'));
            event.preventDefault();
            return false;
        }
        ,'click .transfer-remote-local':function(){
            this.vent.trigger('transfer:remote-to-local');
        }
        ,'rendered':function(){
            if(! ($('table', this.el).data('initiated')) ){
                var table = $('table', this.el).DataTable({
                    paging:false
                    ,scrollY:$(window).height()-320
                    ,searching:false
                    ,serverSide:false
                    ,ajaxSource:false
                    ,ordering:false
                    ,info:false
                    ,oLanguage: {
                        "sEmptyTable":"No Files Found"
                    }
                });
                //var oFH = new $.fn.dataTable.FixedHeader( table );
                $('table', this.el).data('initiated', true);
            }
            $( $.fn.dataTable.tables( true ) ).DataTable().columns.adjust();

        }
    }
});

// Instances of this view can be created by calling:
// new Application.Views["fileTransfer/fileBrowserPanel"]()
;;
/*
 *  transferQ
 *  curDevice
 *  devicesCollection
 *  fileCollection
 */

Application.Model.extend({
    name: "fileTransfer/fileManager"
    ,initialize:function( attr, options ){
        var _this = this;
        this.set('sessions', attr.sessions);
        this.set('curPath', '/');
        this.on('change:curPath', function( model, value ){
            var files = _this.get('filesCollection');
            files.path = value;
            files.fetch();
        });

        //remote sessions
        if( attr.sessions != 'local' ){
            this.initializeRemoteDevice();
        }
        else{
        this.set( 'filesCollection',
            new Thorax.Collections["fileTransfer/file"](null, {
                session:'local'
                ,devices:undefined
                ,path: '/'}))
            var files = this.get('filesCollection');
            files.fetch();
        }

        this.get( 'transferQ' ).on('sync', function(){
            _this.transferQFileCollMerge();
        });
    }
    ,initializeRemoteDevice:function(){
        var _this = this;
        var session = this.get('sessions').getSelected().get('id');

        this.get('sessions').on('change:selected', function(){
            var files = _this.get('filesCollection');
            files.session = _this.get('sessions').getSelected().get('id');

            files.fetch();
        })

        this.set('devicesCollection',
             new Thorax.Collections["fileTransfer/devices"](null)
        );
        var devices = this.get('devicesCollection');

        this.set( 'filesCollection',
            new Thorax.Collections["fileTransfer/file"](null, {
                session:session
                ,devices:devices
                ,path: '/'}))

        //this.get('filesCollection').devices = devices;
         devices.fetch({
            success:function(){
                devices.initSelected();
                var files = _this.get('filesCollection');
                files.path = '/';
                files.fetch();
            }
            ,error:function(e){
                console.log(arguments, "ERROR")
            }
        });
    }
    ,transferQFileCollMerge:function(){
        var _this = this;
        var q = this.get('transferQ');
        //var fileColl = this.get('filesCollection').clone();
        var fileColl = this.get('filesCollection');

        q.each(function(queuedFile) {
            var filePath = queuedFile.get('path');
            var matchingFile = fileColl.findWhere({path:filePath});
            if( matchingFile ){
                matchingFile.set('transferQStatus', queuedFile.toJSON());
            }
        });

        var filesWithQ = fileColl.filter(function(files) {
            return files.get('transferQStatus') != undefined;
        });
        _.each(filesWithQ, function(file){
            var filePath = file.get('path');
            var matchingQ = q.findWhere({path:filePath});
            if( !(matchingQ) ){
                file.unset('transferQStatus');
            }
        });

        this.set('filesCollWithStatus', fileColl);
    }
});

// Instances of this model can be created by calling:
// new Application.Models["fileTransfer/fileManager"]()
;;


  if (Application['fileTransfer'] !== module.exports) {
    console.warn("Application['fileTransfer'] internally differs from global");
  }
  return module.exports;
}).call(this);
