var _ = require('underscore'),
    deferred = require('deferred'),
    plugins = {},
    tsvCounter = 0;


/**
 Returns new TS Version
 @function getTsv
 @return {Number} Returns number with range 0-15
 */

function getTsv() {
    tsvCounter++;
    tsvCounter > 15 ? tsvCounter = 0 : tsvCounter;
    return tsvCounter;
}

module.exports = function (session, encSid, decSid, decHost, decPort) {

    console.log('streamToDecoder()...', enc_sid, dec_sid, host, port);

    var self = this,
        def = deferred(),
        pluginTsv = getTsv(),
        params = [
            'ts_ver_num=' + pluginTsv,
            'no_pcr=0',
            'nfw=1',
            'tick_120=%!120KHZ_TICKS',
            'const_br=0',
            'lport=' + decPort,
            'ltcp_queue_ms=5000',
            'ltcp_clients=20',
            'adapt_br=0',
            'start_enabled=1',
            'host=',
            'port=9710',
            'protocol=udp'
        ];

    session.addPluginParams('udpts', params)(function (pluginId) {

        console.log('streamToDecoder() success adding plugin params:', pluginId);

        session.loadPlugin(pluginId)(function () {
            var pluginData = {
                    encSid: encSid,
                    encSid: decSid,
                    plugin: 'udpts',
                    port: decPort,
                    pluginId: pluginId,
                    tsv: pluginTsv,
                    result: 'success'
                },

                payload = {
                    enc_sid: encSid,
                    dec_sid: decSid,
                    value: pluginData
                };

            def.resolve(payload);

            console.log('streamToDecoder() success loading plugin:', payload);

        }, function (err) {
            console.log('streamToDecoder() failed loading plugin:', err.toString());
        });
    }, function (err) {
        console.log('streamToDecoder() failed adding plugin params:', err.toString());
    });


    ioctl(enc_sid, options).add_plugin_init_params(params_str)(function (data) {
        ioctl(enc_sid, options).load_plugin(pluginId)(function (data) {


            console.log('streamToDecoder() success! port:', port);

        }, function (err) {

            socket.send('start_stream', {
                enc_sid: enc_sid,
                dec_sid: dec_sid,
                value: { result: 'fail', error: err.toString() }
            });

            console.log('streamToDecoder() load_plugin fail...', err);
        });
    }, function (err) {

        socket.send('start_stream', {
            enc_sid: enc_sid,
            dec_sid: dec_sid,
            value: { result: 'fail', error: err.toString() }
        });

        console.log('streamToDecoder() add_plugin_init_params fail...', err);
    });

    return def.promise;
}