var _        = require('underscore'),
    fs       = require('fs'),
    exec     = require('child_process').exec,
    deferred = require('deferred'),
    Pid;

Pid = function(pidfile) {

    var api = {
        add: function(pid) {
            fs.appendFile(pidfile, pid + '\n');
        },

        reset: function() {
            var def = deferred();

            fs.open(pidfile, 'w', function(err) {
                def.resolve(err || 1);
            });

            return def.promise;
        },

        killall: function() {
            var def = deferred();

            fs.readFile(pidfile, 'utf8', function(err, data) {
                if (err) {
                    fs.open(pidfile, 'w', function(err) {
                        def.resolve(err || 1);
                    });
                } else {
                    _.each(data.split('\n'), function(pid) {
                        if (pid.length > 0) {
                            var command = 'kill ' + pid;
                            exec(command);
                            console.log(command);
                        }
                    });

                    api.reset()(function() {
                        def.resolve(1);
                    }, function(err) {
                        def.resolve(err);
                    });
                }
            });

            return def.promise;
        }
    }

    return api;
}

module.exports = Pid;